#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include <atari.h>

#define SIO_BUFFER_SIZE 1024
#define SIO_SMART_DEV_ID 0x45
#define SIO_TIMEOUT 0x03
#define CR 0x0D
#define LF 0x0A

char sio_buffer[SIO_BUFFER_SIZE];

void getUserInput()
{
   unsigned len;
   fgets(sio_buffer, sizeof(sio_buffer), stdin);
   len = strlen(sio_buffer);
   if (len >= 1 && sio_buffer[len - 1] == '\n')
          sio_buffer[len - 1] = '\0';
}

void uploadURL()
{
   int len = strlen(sio_buffer);
   DCB.device = SIO_SMART_DEV_ID;
   DCB.unit = 1;
   DCB.command = 0x55; /* SUBMIT URL */
   DCB.status = 0x80;  /* OUTPUT type operation*/
   DCB.buffer = sio_buffer;
   DCB.timeout = SIO_TIMEOUT;
   DCB.xfersize = len;
   DCB.aux1 = DCB.xfersize & 0xFF;
   DCB.aux2 = (DCB.xfersize >> 8) & 0xFF;
   __asm__ ("jsr $E459");
}

int main(void)
{
   char* fromServer = NULL;
   clrscr ();
   printf("Enter the URL\nfor example: http://www.google.com\n");
   getUserInput();
   uploadURL();
   cgetc();
   return EXIT_SUCCESS;
}
